unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Menus, Math, Role, ComCtrls;

type
  TEditKind = (ekTerrs, ekItems, ekRole); // TؽsҦ: a, ~ΥD
  
  TMainForm = class(TForm)
    pnlView: TPanel;
    pbxView: TPaintBox;
    grdPreview: TDrawGrid;
    GroupBox1: TGroupBox;
    lblTileNo: TLabel;
    nbkTileAttr: TNotebook;
    cbxCanPass: TCheckBox;
    cbxTarget: TCheckBox;
    cbxSource: TCheckBox;
    cbxCanMove: TCheckBox;
    mnuMain: TMainMenu;
    F1: TMenuItem;
    mnuChooseLevel: TMenuItem;
    N1: TMenuItem;
    mnuExit: TMenuItem;
    H1: TMenuItem;
    mnuAbout: TMenuItem;
    E1: TMenuItem;
    mnuEditTerrs: TMenuItem;
    mnuEditItems: TMenuItem;
    mnuEditRole: TMenuItem;
    N2: TMenuItem;
    mnuShowGrid: TMenuItem;
    mnuShowSpeicalArea: TMenuItem;
    mnuResetTerrs: TMenuItem;
    V1: TMenuItem;
    mnuRemoveItems: TMenuItem;
    mnuShowSpeicalItems: TMenuItem;
    stbMain: TStatusBar;
    N4: TMenuItem;
    mnuRemoveItem: TMenuItem;
    mnuSave: TMenuItem;
    N3: TMenuItem;
    mnuRestoreLevel: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure pbxViewPaint(Sender: TObject);
    procedure mnuEditRoleClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure pbxViewMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure mnuShowSomething(Sender: TObject);
    procedure grdPreviewDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure mnuResetTerrsClick(Sender: TObject);
    procedure grdPreviewClick(Sender: TObject);
    procedure mnuRemoveItemClick(Sender: TObject);
    procedure mnuChooseLevelClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure pbxViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pbxViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuRestoreLevelClick(Sender: TObject);
  private
    FEditKind: TEditKind; // ثesҦ
    FLevelNo: Integer; // ثes誺d
    FModified: Boolean; // JdO_ʹL
    
    FRole: TRole; // ⪫
    FBackBitmap: TBitmap; // double-buffering ΪI bitmap
    
    FCursorX, FCursorY: Integer; // ƹЦm
    FButtonPressed: TMouseButton; // ƹ䪬A
    
    procedure DrawBackBitmap; // øsI bitmap
    procedure UpdateView; // sse
    procedure UpdateControlStatus;

    procedure SetLevelNo(Value: Integer);
    
    procedure MySaveFile; // xsaɮ
    function AskSaveMap: Boolean; // T{O_xsa
    function ValidateMap: Boolean; // ˬdaϬO_Xk
    
    property LevelNo: Integer read FLevelNo write SetLevelNo;
  public
    { Public declarations }
  end;
  
var
  MainForm: TMainForm;
  
implementation

uses util, tiles, Mapunit, about, xFiles, xUtils;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  FEditKind := ekTerrs; // w]aνsҦ
  FButtonPressed := mbMiddle; // ܥثeƹS
  
  FRole := TRole.Create; // D
  
  Terrs := TTerrTiles.Create; // aιϤθT
  Items := TItemTiles.Create; // ~ϤθT
  
  Map := tmap.Create; // da
  try
    FRole.LoadBits; // ŪJDϧ
    
    Terrs.LoadFromFile(AppDir + FN_TERR_ARCHIVE); // ŪJa
    Items.LoadFromFile(AppDir + FN_ITEM_ARCHIVE); // ŪJ~
  except
    on E: Exception do
      begin
        ShowMessage(E.message);
        PostMessage(Handle, WM_CLOSE, 0, 0); // H asynchronous 覡
      end;
  end;
  
  // According tile num and size, adjust dimension of pnlView
  pnlView.ClientWidth := TILE_WIDTH * TILE_NUM_X;
  pnlView.ClientHeight := TILE_HEIGHT * TILE_NUM_Y;
  
  FBackBitmap := TBitmap.Create; // wĥ bitmap
  FBackBitmap.Width := TILE_WIDTH * TILE_NUM_X;
  FBackBitmap.Height := TILE_HEIGHT * TILE_NUM_Y;
  
  LevelNo := 1;
  UpdateControlStatus;
  
  // ƹЦm
  FCursorX := -1;
  FCursorY := -1;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FBackBitmap.Free;
  
  FRole.Free;
  
  Terrs.Free;
  Items.Free;
  
  Map.Free;
end;

procedure TMainForm.UpdateView;
begin
  DrawBackBitmap;
  pbxView.Canvas.Draw(0, 0, FBackBitmap);
end;

procedure TMainForm.pbxViewPaint(Sender: TObject);
begin
  UpdateView;
end;

procedure TMainForm.DrawBackBitmap;
var
  X, Y: Integer;
begin
  Map.DrawTerrMap(FBackBitmap.Canvas); // øsaμh
  Map.DrawItemMap(FBackBitmap.Canvas); // øs~h
  
  // pGϥΪ̷Qݮu, NNueX
  if mnuShowGrid.Checked then
    with FBackBitmap.Canvas do
    begin
      Pen.Color := clBlack;
      Pen.Style := psSolid;
      Pen.Width := 1;
      
      // eu
      for Y := 0 to TILE_NUM_Y - 1 do
      begin
        MoveTo(0, Y * TILE_HEIGHT);
        LineTo(TILE_NUM_X * TILE_WIDTH, Y * TILE_HEIGHT);
      end;
      
      // Aeu
      for X := 0 to TILE_NUM_X - 1 do
      begin
        MoveTo(X * TILE_WIDTH, 0);
        LineTo(X * TILE_WIDTH, TILE_NUM_Y * TILE_HEIGHT);
      end;
    end;
  
  // pGϥΪ̷QݯSϰ, NتaaμХX
  if mnuShowSpeicalArea.Checked then
    with FBackBitmap.Canvas do
    begin
      Pen.Color := clRed;
      Pen.Width := 1;
      Pen.Style := psDash;
      Brush.Style := bsClear;
      
      for Y := 0 to TILE_NUM_Y - 1 do // v@ˬd
        for X := 0 to TILE_NUM_X - 1 do
          if Map.IsTarget[X, Y] then
          begin // ~إ[WkWe쥪Uu
            Rectangle(X * TILE_WIDTH, Y * TILE_HEIGHT, (X + 1) * TILE_WIDTH - 1, (Y + 1) * TILE_HEIGHT - 1);
            MoveTo((X + 1) * TILE_WIDTH, Y * TILE_HEIGHT);
            LineTo(X * TILE_WIDTH, (Y + 1) * TILE_HEIGHT);
          end;
    end;
  
  // pGϥΪ̷QݯS~, Nл\Ϊ~ХX
  if mnuShowSpeicalItems.Checked then
    with FBackBitmap.Canvas do
    begin
      Pen.Color := clLime;
      Pen.Width := 1;
      Pen.Style := psDash;
      Brush.Style := bsClear;
      
      for Y := 0 to TILE_NUM_Y - 1 do
        for X := 0 to TILE_NUM_X - 1 do
          if Map.IsSource[X, Y] then
          begin // ~إ[WWekUGu
            Rectangle(X * TILE_WIDTH, Y * TILE_HEIGHT, (X + 1) * TILE_WIDTH - 1, (Y + 1) * TILE_HEIGHT - 1);
            MoveTo(X * TILE_WIDTH, Y * TILE_HEIGHT);
            LineTo((X + 1) * TILE_WIDTH, (Y + 1) * TILE_HEIGHT);
          end;
    end;
  
  FRole.Draw(FBackBitmap.Canvas); // ̫eXϮ
end;

procedure TMainForm.UpdateControlStatus;
begin
  Caption := Format('%s - Level %d',[Application.Title, FLevelNo]);
end;

procedure TMainForm.SetLevelNo(Value: Integer);
begin
  try
    // ŪaɤΨm
    Map.LevelNo := Value;
  except
    // YŪaɥ, Mia
    Map.ResetMap;
  end;
  FRole.X := Map.Role_X; // Nm Map 󤤧ۥX
  FRole.Y := Map.Role_Y;
  
  FLevelNo := Value;
  FModified := False; // aϩ|ʡ]M:p^
  UpdateControlStatus;
  UpdateView; // OѤFsCe
end;

procedure TMainForm.mnuEditRoleClick(Sender: TObject);
const
  Kinds: array[0..2] of TEditKind  = (ekTerrs, ekItems, ekRole);
  Colors: array[Boolean] of TColor = (clBtnFace, clWindow);     
var
  bEnable: Boolean;
begin
  (Sender as TMenuItem).Checked := True;
  FEditKind := Kinds[(Sender as TMenuItem).Tag]; // ]wsҦ
  
  UpdateControlStatus;
  UpdateView;
  
  bEnable := FEditKind <> ekRole; // Ys訤⪬A, hݥΨ grdPreview
  grdPreview.Enabled := bEnable;
  grdPreview.Color := Colors[bEnable];
  grdPreview.Invalidate;

  case FEditKind of
    ekTerrs:
    begin
      nbkTileAttr.PageIndex := 0;
      grdPreview.RowCount := Max(10, Terrs.TileRowCount);
    end;
    
    ekItems:
    begin
      nbkTileAttr.PageIndex := 1;
      grdPreview.RowCount := Max(10, Items.TileRowCount);
    end;
  end;
end;

procedure TMainForm.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.pbxViewMouseMove(Sender: TObject; Shift: TShiftState;
    X, Y: Integer);
begin
  // wg]Xd~F...
  if (X < 0) or (X >= TILE_WIDTH * TILE_NUM_X) or (Y < 0) or
    (Y >= TILE_HEIGHT * TILE_NUM_Y) then Exit;

  FCursorX := X div TILE_WIDTH; // y, HϮ欰
  FCursorY := Y div TILE_HEIGHT;

  // @Ԧ@m񪫫~ĪG
  pbxViewMouseDown(Sender, FButtonPressed, Shift, X, Y);

  UpdateView; // øCe

  // eXثeҿϰ~
  with pbxView.Canvas do
  begin
    Pen.Width := 2;
    Pen.Color := clBlue;
    Brush.Style := bsClear;
    Rectangle(FCursorX * TILE_WIDTH, FCursorY * TILE_HEIGHT,
      (FCursorX + 1) * TILE_WIDTH, (FCursorY + 1) * TILE_HEIGHT);
  end;
  
  stbMain.SimpleText := Format('Position: (%d, %d)',[FCursorX, FCursorY]);
end;

procedure TMainForm.mnuShowSomething(Sender: TObject);
begin
  (Sender as TMenuItem).Checked := not (Sender as TMenuItem).Checked;
  UpdateView;
end;

procedure TMainForm.grdPreviewDrawCell(Sender: TObject; ACol,
    ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  No    : Integer;
  bEmpty: Boolean; // O_ݭn
begin
  No := ARow * grdPreview.ColCount + ACol;
  
  bEmpty := False;
  case FEditKind of
    ekTerrs:
      if No < Terrs.TileNum then
        BitBlt(grdPreview.Canvas.Handle, Rect.Left, Rect.Top, TILE_WIDTH, TILE_HEIGHT,
        Terrs.Bitmap.Canvas.Handle, Terrs.TilePos_Left[No], Terrs.TilePos_Top[No], SRCCOPY)
      else
        bEmpty := True;
      
    ekItems:
      if No < Terrs.TileNum then
        BitBlt(grdPreview.Canvas.Handle, Rect.Left, Rect.Top, TILE_WIDTH, TILE_HEIGHT,
        Items.Bitmap.Canvas.Handle, Items.TilePos_Left[No], Items.TilePos_Top[No], SRCCOPY)
      else
        bEmpty := True;
  end;

  if bEmpty then
  begin
    grdPreview.Canvas.Brush.Color := clBlack;
    grdPreview.Canvas.FillRect(Rect);
  end;
end;

procedure TMainForm.mnuResetTerrsClick(Sender: TObject);
begin
  case (Sender as TComponent).Tag of
    0: Map.ResetTerrs;
    1: Map.ResetItems;
  end;
  UpdateView;
end;

procedure TMainForm.grdPreviewClick(Sender: TObject);
var
  No: Integer;
begin
  with grdPreview do
    No := Row * ColCount + Col;
  
  // ܿݩ  
  case FEditKind of
    ekTerrs:
    begin
      cbxCanPass.Checked := taCanpass in Terrs.Attrs[No];
      cbxTarget.Checked := taTarget in Terrs.Attrs[No];
    end;
    
    ekItems:
    begin
      cbxCanMove.Checked := iaCanmove in Items.Attrs[No];
      cbxSource.Checked := iasource in Items.Attrs[No];
    end;
  end;
end;

procedure TMainForm.mnuRemoveItemClick(Sender: TObject);
begin
  if (FCursorX = -1) or (FCursorY = -1) then Exit;
  
  Map.ItemMap[FCursorX, FCursorY] := 0;
  UpdateView;
end;

procedure TMainForm.mnuChooseLevelClick(Sender: TObject);
var
  S: string;
begin
  if not AskSaveMap then Exit;
  
  S := IntToStr(FLevelNo);
  if InputQuery(Application.Title, 'Input Level No:', S) then
    LevelNo := StrToInt(S);
end;

function TMainForm.AskSaveMap: Boolean;
begin
  Result := True;
  if not FModified then Exit;
  
  // T{O_xsثes誺aɮ
  case YesNoCancelBox(Format('Do you want to save this map (level %d) ?',[FLevelNo])) of
    mrYes: MySaveFile;
      
    mrNo:;

    mrCancel: Result := False;
  end;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if not AskSaveMap then CanClose := False;
end;

procedure TMainForm.MySaveFile;
begin
  if not FModified then Exit;
  if not ValidateMap then Exit;
  
  Map.Role_X := FRole.X;
  Map.Role_Y := FRole.Y;
  Map.SaveToFile;
  FModified := False;
end;

procedure TMainForm.mnuSaveClick(Sender: TObject);
begin
  MySaveFile;
end;

// ˬdaϬO_Xk
function TMainForm.ValidateMap: Boolean;
var
  X, Y                    : Integer;
  SourceCount, TargetCount: Integer;
begin
  Result := False;

  SourceCount := 0; // л\Ϊ~ƥ
  TargetCount := 0; // تaμƥ
  for Y := 0 to TILE_NUM_Y - 1 do
    for X := 0 to TILE_NUM_X - 1 do
    begin
      // pл\Ϊ~Υتaμƥ
      if Map.IsSource[X, Y] then Inc(SourceCount);
      if Map.IsTarget[X, Y] then Inc(TargetCount);

      // aϤOϤsOOjϮwϤƥ ? OܴNզ^w]
      if Map.TerrMap[X, Y] > Terrs.TileNum then Map.TerrMap[X, Y] := 0;
      if Map.ItemMap[X, Y] > Items.TileNum then Map.ItemMap[X, Y] := 0;
    end;

  // O_Sتa ? (LkL)
  if (TargetCount = 0) and not YesNoBox('Sتa, O_~H') then Exit;

  // O_л\Ϊ~֩تa ? (LkL)
  if (TargetCount > SourceCount) and not YesNoBox('л\Ϊ~֩تa, O_~H') then Exit;

  // 󤣯ಾʪaΤW
  if not Map.CanPass[Map.Role_X, Map.Role_Y] and not YesNoBox('D󤣯ಾʪaΤW, O_~H') then Exit;

  Result := True;
end;

procedure TMainForm.mnuAboutClick(Sender: TObject);
begin
  with TAboutBox.Create(self) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TMainForm.pbxViewMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
var
  No: Integer;
begin
  // NUO_, tX OnMouseMove event handler ͩԦ]wĪG
  FButtonPressed := Button;

  if Button = mbMiddle then Exit; // ƹ䤣

  with grdPreview do
    No := Row * ColCount + Col; // pثeܪϤs

  if Button = mbLeft then // O]w
  begin
    case FEditKind of // ھڽsҦPi椣P]wʧ@
      ekTerrs:
        Map.TerrMap[FCursorX, FCursorY] := No; // Nsa\W

      ekItems:
      begin
        // ~i\b⨭W
        if (FRole.X = FCursorX) and (FRole.Y = FCursorY) then Exit;

        Map.ItemMap[FCursorX, FCursorY] := No; // Ns\W
      end;

      ekRole:
      begin
        // ⤣iH\b~W
        if Map.ItemMap[FCursorX, FCursorY] <> 0 then Exit;
        // ⤣iH\biʪaΤW
        if not Map.CanPass[FCursorX, FCursorY] then Exit;

        FRole.X := FCursorX; // ]wm
        FRole.Y := FCursorY;
      end;
    end;
  end else // kOM
  begin
    case FEditKind of
      ekTerrs: Map.TerrMap[FCursorX, FCursorY] := 0; // Ma

      ekItems: Map.ItemMap[FCursorX, FCursorY] := 0; // M~

      ekRole: ; // ⤣M, so do nothing
    end;
  end;

  FModified := True;
  UpdateView;
end;

procedure TMainForm.pbxViewMouseUp(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
  FButtonPressed := mbMiddle; // ]w mbMiddle ܨϥΪ̤w}ƹ
end;

procedure TMainForm.mnuRestoreLevelClick(Sender: TObject);
begin
  LevelNo := LevelNo;
end;


end.

