unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, mmsystem,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    btnVCL: TButton;
    imgSrc: TImage;
    imgDst: TImage;
    btnNineSteps: TButton;
    btnNormal: TButton;
    procedure btnVCLClick(Sender: TObject);
    procedure btnNineStepsClick(Sender: TObject);
    procedure btnNormalClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  
var
  Form1: TForm1;
  
implementation

{$R *.DFM}

procedure TForm1.btnVCLClick(Sender: TObject);
var
  Bits: TBitmap;
begin
  Bits := TBitmap.Create; // إ߼Ȯɪ TBitmap
  Bits.Assign(imgSrc.Picture.Bitmap); // NlvL
  Bits.Transparent := True;
//  Bits.TransparentColor := RGB(128, 0, 0); // ]wBnC

  imgDst.Canvas.Brush.Color := clBtnFace;  
  imgDst.Canvas.FillRect(imgDst.Canvas.ClipRect);
  imgDst.Canvas.Draw(0, 0, Bits); // ƻsتeW
  Bits.Free;
end;

procedure TransparentBlt(DestDC: HDC; srcBmp: THandle; DestX, DestY: Integer; TransColor: Longint);
var
  bmp         : Windows.TBitmap; {description of the source bitmap}
  OrigColor   : Longint;         {Holds original background color from source DC}
  bSuccess    : Boolean;         {Stores result of call to Windows API}

  SrcDC       : HDC;             {source bitmap (color)}
  SaveDC      : HDC;             {backup copy of source bitmap}
  MaskDC      : HDC;             {mask bitmap (monochrome)}
  invDC       : HDC;             {inverse of mask bitmap (monochrome)}
  resultDC    : HDC;             {combination of source bitmap & background}
  
  hResultBmp  : THandle;         {Bitmap combination of source & background}
  hSaveBmp    : THandle;         {Bitmap stores backup copy of source bitmap}
  hMaskBmp    : THandle;         {Bitmap stores mask (monochrome)}
  hInvBmp     : THandle;         {Bitmap holds inverse of mask (monochrome)}
  hPrevBmp    : THandle;         {Bitmap holds previous bitmap selected in DC}
  hSrcPrevBmp : THandle;         {Holds previous bitmap in source DC}
  hSavePrevBmp: THandle;         {Holds previous bitmap in saved DC}
  hDestPrevBmp: THandle;         {Holds previous bitmap in destination DC}
  hMaskPrevBmp: THandle;         {Holds previous bitmap in the mask DC}
  hInvPrevBmp : THandle;         {Holds previous bitmap in inverted mask DC}
begin
  {Retrieve bitmap to get width (bmp.bmWidth) & height (bmp.bmHeight)}
  bSuccess := Boolean(GetObject(srcBmp, SizeOf(bmp), @bmp));
  SrcDC := CreateCompatibleDC(DestDC); {Create DC to hold stage}
  SaveDC := CreateCompatibleDC(DestDC); {Create DC to hold stage}
  MaskDC := CreateCompatibleDC(DestDC); {Create DC to hold stage}
  invDC := CreateCompatibleDC(DestDC); {Create DC to hold stage}
  resultDC := CreateCompatibleDC(DestDC); {Create DC to hold stage}

  {Create monochrome bitmaps for the mask-related bitmaps:}
  hMaskBmp := CreateBitmap(bmp.bmWidth, bmp.bmHeight, 1, 1, nil);
  hInvBmp := CreateBitmap(bmp.bmWidth, bmp.bmHeight, 1, 1, nil);

  {Create color bitmaps for final result & stored copy of source}
  hResultBmp := CreateCompatibleBitmap(DestDC, bmp.bmWidth, bmp.bmHeight);
  hSaveBmp := CreateCompatibleBitmap(DestDC, bmp.bmWidth, bmp.bmHeight);
  hSrcPrevBmp := SelectObject(SrcDC, srcBmp); {Select bitmap in DC}
  hSavePrevBmp := SelectObject(SaveDC, hSaveBmp); {Select bitmap in DC}
  hMaskPrevBmp := SelectObject(MaskDC, hMaskBmp); {Select bitmap in DC}
  hInvPrevBmp := SelectObject(invDC, hInvBmp); {Select bitmap in DC}
  hDestPrevBmp := SelectObject(resultDC, hResultBmp); {Select bitmap}

  {Make backup of source bitmap to restore later}
  bSuccess := BitBlt(SaveDC, 0, 0, bmp.bmWidth, bmp.bmHeight, SrcDC, 0, 0, SRCCOPY);
  
  {Create mask: set background color of source to transparent color.}
  OrigColor := SetBkColor(SrcDC, TransColor);
  bSuccess := BitBlt(MaskDC, 0, 0, bmp.bmWidth, bmp.bmHeight, SrcDC, 0, 0, SRCCOPY);
  TransColor := SetBkColor(SrcDC, OrigColor);
  
  {Create inverse of mask to AND w/ source & combine w/ background.}
  bSuccess := BitBlt(invDC, 0, 0, bmp.bmWidth, bmp.bmHeight, MaskDC, 0, 0, NOTSRCCOPY);
  
  {Copy background bitmap to result & create final transparent bitmap}
  bSuccess := BitBlt(resultDC, 0, 0, bmp.bmWidth, bmp.bmHeight,
    DestDC, DestX, DestY, SRCCOPY);
  
  {AND mask bitmap w/ result DC to punch hole in the background by
    painting black area for non-transparent portion of source bitmap.}
  bSuccess := BitBlt(resultDC, 0, 0, bmp.bmWidth, bmp.bmHeight, MaskDC, 0, 0, SRCAND);
  
  {AND inverse mask w/ source bitmap to turn off bits associated
    with transparent area of source bitmap by making it black.}
  bSuccess := BitBlt(SrcDC, 0, 0, bmp.bmWidth, bmp.bmHeight, invDC, 0, 0, SRCAND);
  
  {XOR result w/ source bitmap to make background show through.}
  bSuccess := BitBlt(resultDC, 0, 0, bmp.bmWidth, bmp.bmHeight, SrcDC, 0, 0, SRCPAINT);

  {Display transparent bitmap on backgrnd}
  bSuccess := BitBlt(DestDC, DestX, DestY, bmp.bmWidth, bmp.bmHeight, resultDC, 0, 0, SRCCOPY);

  {Restore backup of bitmap.}
  bSuccess := BitBlt(SrcDC, 0, 0, bmp.bmWidth, bmp.bmHeight, SaveDC, 0, 0, SRCCOPY);

  hPrevBmp := SelectObject(SrcDC, hSrcPrevBmp); {Select orig object}
  hPrevBmp := SelectObject(SaveDC, hSavePrevBmp); {Select orig object}
  hPrevBmp := SelectObject(resultDC, hDestPrevBmp); {Select orig object}
  hPrevBmp := SelectObject(MaskDC, hMaskPrevBmp); {Select orig object}
  hPrevBmp := SelectObject(invDC, hInvPrevBmp); {Select orig object}

  bSuccess := DeleteObject(hSaveBmp); {Deallocate system resources.}
  bSuccess := DeleteObject(hMaskBmp); {Deallocate system resources.}
  bSuccess := DeleteObject(hInvBmp); {Deallocate system resources.}
  bSuccess := DeleteObject(hResultBmp); {Deallocate system resources.}

  bSuccess := DeleteDC(SrcDC); {Deallocate system resources.}
  bSuccess := DeleteDC(SaveDC); {Deallocate system resources.}
  bSuccess := DeleteDC(invDC); {Deallocate system resources.}
  bSuccess := DeleteDC(MaskDC); {Deallocate system resources.}
  bSuccess := DeleteDC(resultDC); {Deallocate system resources.}
end;

(* C y zKϨ禡
   ӷ: Microsoft Knowledge Base
         HOWTO: Drawing Transparent Bitmaps
         Article ID: Q79212

  void DrawTransparentBitmap(HDC hdc, HBITMAP hBitmap, short xStart,
                           short yStart, COLORREF cTransparentColor)
   {
   BITMAP     bm;
   COLORREF   cColor;
   HBITMAP    bmAndBack, bmAndObject, bmAndMem, bmSave;
   HBITMAP    bmBackOld, bmObjectOld, bmMemOld, bmSaveOld;
   HDC        hdcMem, hdcBack, hdcObject, hdcTemp, hdcSave;
   POINT      ptSize;

   hdcTemp = CreateCompatibleDC(hdc);
   SelectObject(hdcTemp, hBitmap);   // Select the bitmap

   GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&bm);
   ptSize.x = bm.bmWidth;            // Get width of bitmap
   ptSize.y = bm.bmHeight;           // Get height of bitmap
   DPtoLP(hdcTemp, &ptSize, 1);      // Convert from device
                                     // to logical points

   // Create some DCs to hold temporary data.
   hdcBack   = CreateCompatibleDC(hdc);
   hdcObject = CreateCompatibleDC(hdc);
   hdcMem    = CreateCompatibleDC(hdc);
   hdcSave   = CreateCompatibleDC(hdc);

   // Create a bitmap for each DC. DCs are required for a number of
   // GDI functions.

   // Monochrome DC
   bmAndBack   = CreateBitmap(ptSize.x, ptSize.y, 1, 1, NULL);

   // Monochrome DC
   bmAndObject = CreateBitmap(ptSize.x, ptSize.y, 1, 1, NULL);

   bmAndMem    = CreateCompatibleBitmap(hdc, ptSize.x, ptSize.y);
   bmSave      = CreateCompatibleBitmap(hdc, ptSize.x, ptSize.y);

   // Each DC must select a bitmap object to store pixel data.
   bmBackOld   = SelectObject(hdcBack, bmAndBack);
   bmObjectOld = SelectObject(hdcObject, bmAndObject);
   bmMemOld    = SelectObject(hdcMem, bmAndMem);
   bmSaveOld   = SelectObject(hdcSave, bmSave);

   // Set proper mapping mode.
   SetMapMode(hdcTemp, GetMapMode(hdc));

   // Save the bitmap sent here, because it will be overwritten.
   BitBlt(hdcSave, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCCOPY);

   // Set the background color of the source DC to the color.
   // contained in the parts of the bitmap that should be transparent
   cColor = SetBkColor(hdcTemp, cTransparentColor);

   // Create the object mask for the bitmap by performing a BitBlt
   // from the source bitmap to a monochrome bitmap.
   BitBlt(hdcObject, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0,
          SRCCOPY);

   // Set the background color of the source DC back to the original
   // color.
   SetBkColor(hdcTemp, cColor);

   // Create the inverse of the object mask.
   BitBlt(hdcBack, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0,
          NOTSRCCOPY);

   // Copy the background of the main DC to the destination.
   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdc, xStart, yStart,
          SRCCOPY);

   // Mask out the places where the bitmap will be placed.
   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0, SRCAND);

   // Mask out the transparent colored pixels on the bitmap.
   BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y, hdcBack, 0, 0, SRCAND);

   // XOR the bitmap with the background on the destination DC.
   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCPAINT);

   // Copy the destination to the screen.
   BitBlt(hdc, xStart, yStart, ptSize.x, ptSize.y, hdcMem, 0, 0,
          SRCCOPY);

   // Place the original bitmap back into the bitmap sent here.
   BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y, hdcSave, 0, 0, SRCCOPY);

   // Delete the memory bitmaps.
   DeleteObject(SelectObject(hdcBack, bmBackOld));
   DeleteObject(SelectObject(hdcObject, bmObjectOld));
   DeleteObject(SelectObject(hdcMem, bmMemOld));
   DeleteObject(SelectObject(hdcSave, bmSaveOld));

   // Delete the memory DCs.
   DeleteDC(hdcMem);
   DeleteDC(hdcBack);
   DeleteDC(hdcObject);
   DeleteDC(hdcSave);
   DeleteDC(hdcTemp);
   }

*)

procedure TForm1.btnNineStepsClick(Sender: TObject);
var
  Bits: TBitmap;
begin
  Bits := TBitmap.Create; // إ߼Ȯɪ TBitmap
  Bits.Assign(imgSrc.Picture.Bitmap); // NlvL

  imgDst.Canvas.Brush.Color := clBtnFace;
  imgDst.Canvas.FillRect(Rect(0, 0, 128, 32));

  TransparentBlt(imgDst.Canvas.handle, Bits.Handle, 0, 0, RGB(128, 0, 0));

  Bits.Free;
end;

procedure TForm1.btnNormalClick(Sender: TObject);
begin
  imgDst.Canvas.Draw(0, 0, imgSrc.picture.bitmap);
end;

end.

